unit Numbering;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TNumberingForm = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Edit3: TEdit;
    Label4: TLabel;
    Button2: TButton;
    RadioGroup2: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    CMax: Integer;   // ݂̃Zʒu珑ꍇ̘AԂ̍ő
    SMax: String;    // CMax 𕶎ɕϊ
    CStart: Integer; // ݂̃ZʒuRgΏۂɏꍇ̊Jnԍ
    SStart: String;  // CStart 𕶎ɕϊ
    NStart: String;  // o[R[hΏۂɘAԂ쐬ꍇ̊Jnԍ
    Zero: Boolean;   // f[^ 0 ̂Ƃ True ɐݒ肳ϐ
    function Numbering(var NList: TStringList; Start: String;
     Count: Integer; Element: String; Order: Boolean): Boolean;
    function HasSameData(List: TStringList): Boolean;
  end;

var
  NumberingForm: TNumberingForm;

implementation

uses DataListF;

{$R *.DFM}

{ Start ͂߂āA Element Ɋ܂܂vfgāACount  }
{ ԍtꂽ񃊃Xg쐬ANList Ɋi[֐łB쐬ɐ }
{ ꍇ́ATrue Asꍇ́AFalse Ԃ܂B̊֐g }
{ POiAPUiAQiAWi邢́A'A'..'Z', 'a'..'z' g }
{ lXȔԍtꂽ鎖\łBStart ̌ԍt }
{ 錅ƂȂ܂BOrder ́Aԍt̐/tw肷邽߂̃p[^ }
{ łBႦ΁AElement ̒lȉ̗lɎw肷ƁA}
{ '0123456789'       ===> POiŔԍt܂B}
{ '0123456789ABCDEF' ===> PUiŔԍt܂B}
{ '01'               ===>   QiŔԍt܂B}
{ '01234567'         ===>   WiŔԍt܂B}
{ ̗lɔԍt܂B̂قA'0123456#$%&()~|\<>+-*/abcdefg' ̗l }
{ ĕϑIȃLN^gă[U[Ǝ̔ԍt鎖\łB}

function TNumberingForm.Numbering(var NList: TStringList; Start: String;
 Count: Integer; Element: String; Order: Boolean): Boolean;
var
  i: Integer;
  S: String;
  List: TStringList;

  { ԍtꂽ SN ̍\vf̕ SE Ƃ }
  { 傫(CNg)葱łB}

  procedure IncString(var SN: String; SE: String);
  var
    i, j: Integer;
    Len: Integer;
    S: String;
  begin
    if (SN = '') or (SE = '') then
      Exit;
    S := SN;
    Len := Length(SE);
    for i := Length(S) downto 1 do
    begin
      j := Pos(S[i], SE);
      if j = 0 then // G[(SE ɂȂ)
        Exit
      else if j < Len then
      begin
        S[i] := SE[j + 1]; // ̌CNgďI
        Break;
      end
      else // j = Len
        S[i] := SE[1]; // ̌CNgĎ̌
    end;
    SN := S;
  end;

  { ԍtꂽ SN ̍\vf̕ SE Ƃ }
  { (fNg)葱łB}

  procedure DecString(var SN: String; SE: String);
  var
    i, j: Integer;
    Len: Integer;
    S: String;
  begin
    if (SN = '') or (SE = '') then
      Exit;
    S := SN;
    Len := Length(SE);
    for i := Length(S) downto 1 do
    begin
      j := Pos(S[i], SE);
      if j = 0 then // G[(SE ɂȂ)
        Exit
      else if j = 1 then
      begin
        S[i] := SE[Len]; // ̌fNgĎ̌
      end
      else
      begin
        S[i] := SE[j - 1]; // ̌fNgďI
        Break;
      end;
    end;
    SN := S;
  end;

begin
  Result := False;

  if (NList = Nil) or (Start = '') or (Count < 1) or (Length(Element) < 2) then
    Exit;

  for i := 1 to Length(Start) do
    if Pos(Start[i], Element) = 0 then // Element ɂȂB
      Exit;

  List := TStringList.Create;
  try
    S := Start;
    if Order = True then
    begin
      for i := 1 to Count do
      begin
        List.Add(S);
        IncString(S, Element);
      end;
    end
    else // Order = False
    begin
      for i := Count downto 1 do
      begin
        List.Add(S);
        DecString(S, Element);
      end;
    end;
    if List.Count = Count then
    begin
      NList.Assign(List);
      Result := True;
    end;
  finally
    List.Free;
  end;
end;

{ List ̒ɏdf[^܂܂Ă邩ׂ֐łB}
{ ܂܂Ă΁ATrue Ԃ܂B}

function TNumberingForm.HasSameData(List: TStringList): Boolean;
var
  i, j: Integer;
  S: String;
begin
  Result := False;
  for i := List.Count - 1 downto 1 do
  begin
    S := List.Strings[i];
    for j := i - 1 downto 0 do
    begin
      if List.Strings[j] = S then
      begin
        Result := True;
        Break;
      end;
    end;
    if Result = True then
      Break;
  end;
end;

procedure TNumberingForm.Button1Click(Sender: TObject);
var
  Order: Boolean;
  Err: Boolean;
  i, j, k: Integer;
  Count: Integer;
  r: Integer;
  S: String;
  NList: TStringList;
  List1, List2, List3: TStringList;
begin
  j := ComboBox1.ItemIndex;
  r := DataListForm.StringGrid1.Row; // Z̍sʒu
  S := Edit3.Text;

  for i := 1 to Length(S) do
  begin
    if not (S[i] in ['0'..'9']) then
    begin
      ShowMessage('u쐬v ̎w肪܂B');
      ComboBox1Change(Sender);
      Exit;
    end;
  end;
  Count := StrToInt(S);

  Err := True;
  if RadioGroup2.ItemIndex = 2 then // ݂̃Zʒu珑ꍇ
  begin
    if CMax = 0 then
      ShowMessage('ZʒuŏIs̏ꍇ́AZʒȕ͏o܂B')
    else if (Count > CMax) or (Count < 1) then
      ShowMessage('u쐬v̎w肪܂B')
    else
      Err := False;
  end
  else if Count < 1 then
    ShowMessage('u쐬v ̎w肪܂B')
  else
    Err := False;

  if Err then
  begin
    ComboBox1Change(Sender);
    Exit;
  end;

  if RadioGroup1.ItemIndex = 0 then
    Order := True
  else
    Order := False;

  NList := TStringList.Create;
  List1 := TStringList.Create;
  List2 := TStringList.Create;
  List3 := TStringList.Create;
  try
    if Numbering(NList, Edit1.Text, Count, Edit2.Text, Order) = False then
    begin
      ShowMessage('uJnԍv 邢́AuAԂ̍\vfv ̎w肪܂B');
      Exit;
    end;

    if j = 0 then
    begin
      if RadioGroup2.ItemIndex = 0 then // ݂̃f[^ƒuB
      begin
        List1.Assign(NList);
        for i := 0 to List1.Count do
        begin
          List2.Add('');
          List3.Add('');
        end;
      end
      else if RadioGroup2.ItemIndex = 1 then // ݂̃J[\ʒuɑ}B
      begin
        for i := 1 to r - 1 do // Õf[^
        begin
          List1.Add(DataListForm.StringGrid1.Cells[1, i]);
          List2.Add(DataListForm.StringGrid1.Cells[2, i]);
          List3.Add(DataListForm.StringGrid1.Cells[3, i]);
        end;
        for i := 0 to NList.Count - 1 do // AԂ̃f[^
        begin
          List1.Add(NList.Strings[i]);
          List2.Add('');
          List3.Add('');
        end;
        for i := r to DataListForm.StringGrid1.RowCount - 2 do // 㔼̃f[^
        begin
          List1.Add(DataListForm.StringGrid1.Cells[1, i]);
          List2.Add(DataListForm.StringGrid1.Cells[2, i]);
          List3.Add(DataListForm.StringGrid1.Cells[3, i]);
        end;
      end
      else // ݂̃Zʒu珑B
      begin
        for i := 1 to DataListForm.StringGrid1.RowCount - 2 do // 㔼̃f[^
        begin
          if (i < r) or (i >= r + NList.Count) then
            List1.Add(DataListForm.StringGrid1.Cells[1, i])
          else
            List1.Add(NList.Strings[i - r]);
          List2.Add(DataListForm.StringGrid1.Cells[2, i]);
          List3.Add(DataListForm.StringGrid1.Cells[3, i]);
        end;
      end;

      if HasSameData(List1) then
      begin
        ShowMessage('udf[^v ݂̑AԂ쐬Ă܂܂B');
        Exit;
      end;
    end;

    if j = 0 then
    begin
      DataListForm.StringGrid1.RowCount := List1.Count + 2;

      for i := 1 to DataListForm.StringGrid1.RowCount - 1 do
        DataListForm.StringGrid1.Cells[0, i] := IntToStr(i);

      for i := 1 to DataListForm.StringGrid1.RowCount - 2 do
      begin
        DataListForm.StringGrid1.Cells[1, i] := List1.Strings[i - 1];
        DataListForm.StringGrid1.Cells[2, i] := List2.Strings[i - 1];
        DataListForm.StringGrid1.Cells[3, i] := List3.Strings[i - 1];
      end;
    end
    else if j = 1 then
      for i := 1 to Count do
        DataListForm.StringGrid1.Cells[2, i + r - 1] := NList.Strings[i - 1]
    else
      for i := 1 to Count do
        DataListForm.StringGrid1.Cells[3, i + r - 1] := NList.Strings[i - 1];

    { ŉs̃f[^NA[ĂB}
    k := DataListForm.StringGrid1.RowCount - 1; // ŉs̍sԍ
    DataListForm.StringGrid1.Cells[1, k] := '';
    DataListForm.StringGrid1.Cells[2, k] := '';
    DataListForm.StringGrid1.Cells[3, k] := '';
  finally
    List3.Free;
    List2.Free;
    List1.Free;
    NList.Free;
  end;

  DataListForm.StringGrid1.Row := 1;
  DataListForm.StringGrid1.Col := 1;

  ModalResult := mrOk;
end;

procedure TNumberingForm.ComboBox1Change(Sender: TObject);
begin
  if Zero then // f[^Ȃꍇ
  begin
    ComboBox1.ItemIndex := 0; // o[R[hΏۂɘAԂ쐬B
    RadioGroup2.ItemIndex := 0; //ũ݂f[^ƒuBv
  end
  else if ComboBox1.ItemIndex > 0 then // RgΏۂɘAԂ쐬ꍇ
    RadioGroup2.ItemIndex := 2; //ũ݂Zʒu珑BvɌŒ

  if RadioGroup2.ItemIndex = 2 then //ũ݂Zʒu珑Bv
  begin
    Edit3.Text := SMax;
    if ComboBox1.ItemIndex = 0 then // o[R[hΏۂɘAԂ쐬ꍇ
      Edit1.Text := NStart
    else // RgΏۂɘAԂ쐬ꍇ
      Edit1.Text := SStart;
  end
  else
  begin
    Edit3.Text := '1000';
    Edit1.Text := NStart;
  end;
end;

procedure TNumberingForm.FormShow(Sender: TObject);
var
  m, n, r: Integer;
begin
  n := DataListForm.StringGrid1.RowCount - 2; // f[^̑
  if n = 0 then
    Zero := True
  else
    Zero := False;

  CStart := DataListForm.StringGrid1.Row; // Z̍sʒu
  CMax := n - (CStart - 1); // Z̍sʒuȍ~̃f[^̐
  SMax := IntToStr(CMax);
  SStart := IntToStr(CStart);

  m := Length(IntToStr(n));
  if m < 4 then
    m := 4;
  while Length(SStart) < m do
    SStart := '0' + SStart;

  r := DataListForm.StringGrid1.Row; // Z̍sʒu
  if (r = DataListForm.StringGrid1.RowCount - 1) and (r > 1) then
    Dec(r); // ŉsɂ́Af[^Ȃ̂ňO̍sI
  NStart := DataListForm.StringGrid1.Cells[1, r];
  if NStart = '' then
    NStart := '490123456789';

  ComboBox1.ItemIndex := DataListForm.StringGrid1.Col - 1;
  ComboBox1Change(Sender);
end;

procedure TNumberingForm.Button2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TNumberingForm.RadioGroup2Click(Sender: TObject);
begin
  ComboBox1Change(Sender);
end;

end.
